/* This file is part of X2C. http://www.mechatronic-simulation.org/                                                   */

/* Model: DemoApplication                                                                                             */
/* Date:  2015-07-29 14:29                                                                                            */

#ifndef __X2C_H__
#define __X2C_H__

/**********************************************************************************************************************/
/**     Includes                                                                                                     **/
/**********************************************************************************************************************/
#include "Constant_FiP16.h"
#include "SinGen_FiP16.h"
#include "AutoSwitch_FiP16.h"
#include "Sin3Gen_FiP16.h"
#include "Scope_Main.h"
#include "CommonFcts.h"

/**********************************************************************************************************************/
/**     Defines                                                                                                      **/
/**********************************************************************************************************************/
#define FUNCTIONS CONSTANT_FIP16_FUNCTIONS , \
                  SINGEN_FIP16_FUNCTIONS , \
                  AUTOSWITCH_FIP16_FUNCTIONS , \
                  SIN3GEN_FIP16_FUNCTIONS , \
                  SCOPE_MAIN_FUNCTIONS 

#define PARAMETER_TABLE { (uint16)1, &TAmplitude } , \
                        { (uint16)2, &TAutoSwitch } , \
                        { (uint16)3, &TFrequency } , \
                        { (uint16)4, &TLED_off } , \
                        { (uint16)5, &TLED_on } , \
                        { (uint16)6, &TSin3Gen } , \
                        { (uint16)7, &TSinGen } , \
                        { (uint16)8, &TScope } , \
                        { (uint16)9, &Inports.Adc_A0 } , \
                        { (uint16)10, &Inports.Adc_B0 } , \
                        { (uint16)11, &Inports.Gpio_33 } , \
                        { (uint16)12, &Outports.pLed2 } 

/**********************************************************************************************************************/
/**     Typdefs                                                                                                      **/
/**********************************************************************************************************************/

/* Inport structure                                                                                                   */
typedef struct 
{
    int16 Adc_A0;
    int16 Adc_B0;
    int16 Gpio_33;
} TInports;

/* Outport structure                                                                                                  */
typedef struct 
{
    int16* pLed2;
} TOutports;

/**********************************************************************************************************************/
/**     Externals                                                                                                    **/
/**********************************************************************************************************************/
extern TInports Inports;
extern TOutports Outports;
extern const tBlockFunctions blockFunctionTable[];
extern const tParameterTable parameterIdTable[];


/**********************************************************************************************************************/
/**     Prototypes                                                                                                   **/
/**********************************************************************************************************************/
void X2C_Init(void);
void X2C_Update(void);
void X2C_Update_1(void);


#endif
