function [System] = getCurrentSystem()
// Copyright (c) 2014, Linz Center of Mechatronics GmbH (LCM) http://www.lcm.at/
// All rights reserved.
//
// This file is licensed according to the BSD 3-clause license as follows:
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//     * Redistributions of source code must retain the above copyright
//       notice, this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright
//       notice, this list of conditions and the following disclaimer in the
//       documentation and/or other materials provided with the distribution.
//     * Neither the name of the "Linz Center of Mechatronics GmbH" and "LCM" nor
//       the names of its contributors may be used to endorse or promote products
//       derived from this software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
// IN NO EVENT SHALL "Linz Center of Mechatronics GmbH" BE LIABLE FOR ANY
// DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// This file is part of X2C. http://www.mechatronic-simulation.org/
// $LastChangedRevision: 503 $
//
// Returns name of open diagram

jimport org.scilab.modules.xcos.Xcos;

Xcos = jinvoke(Xcos, "getInstance");
OpenDiagrams = jinvoke(Xcos, "openedDiagrams");
if isVersionLessThan("5.5.0") then
    NrOfDiagrams = junwrap(jinvoke(OpenDiagrams, "size"));
else
    NrOfDiagrams = jinvoke(OpenDiagrams, "size");
end

// check the number of open diagrams
if NrOfDiagrams < 1 then
    disp("No open diagram found!");
    System = "";
elseif NrOfDiagrams > 1 then
    disp("More than one open diagram found, don''t know which to choose!");
    System = "";
else
    // exactly one open diagram was found
    Diagram = jinvoke(OpenDiagrams, "get", 0);
    if isVersionLessThan("5.5.0") then
        System = junwrap(jinvoke(Diagram, "getTitle"));
    else
        System = jinvoke(Diagram, "getTitle");
    end
    
end

endfunction
