// Copyright (c) 2014, Linz Center of Mechatronics GmbH (LCM) http://www.lcm.at/
// All rights reserved.
//
// This file is licensed according to the BSD 3-clause license as follows:
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//     * Redistributions of source code must retain the above copyright
//       notice, this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright
//       notice, this list of conditions and the following disclaimer in the
//       documentation and/or other materials provided with the distribution.
//     * Neither the name of the "Linz Center of Mechatronics GmbH" and "LCM" nor
//       the names of its contributors may be used to endorse or promote products
//       derived from this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
// IN NO EVENT SHALL "Linz Center of Mechatronics GmbH" BE LIABLE FOR ANY
// DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

function subdemolist = demo_gateway()

    demopath = get_absolute_file_path("X2C.dem.gateway.sce");
    add_demo("X2C", demopath + "X2C.dem.gateway.sce");

    subdemolist = [_("Blinky AM335x BeagleBoneBlack")      , "AM335x_BeagleBoneBlack.dem.sce"       ; ..
    _("Blinky Atmel ATSAM3X8E ArduinoDue")     , "Atmel_ATSAM3X8E_ArduinoDue.dem.sce"    ; ..
    _("Blinky Microchip dsPIC33EP X2CDevBoard")  , "Microchip_dsPIC33EP_X2CDevBoard.dem.sce" ; ..
    _("Blinky Microchip dsPIC33Fxxxx MicrostickPlus")  , "Microchip_dsPIC33Fxxxx_MicrostickPlus.dem.sce" ; ..
    _("Blinky ST STM32F051R8 Discovery")  , "ST_STM32F051R8_Discovery.dem.sce" ; ..
    _("Blinky TI TM4C123GH6 LaunchPad")  , "TI_TM4C123GH6_LaunchPad.dem.sce" ; ..
    _("Blinky TI TMS320F28069 controlSTICK")  , "TI_TMS320F28069_controlSTICK.dem.sce" ; ..
    _("Blinky TI TMS320F28335 controlCARD")  , "TI_TMS320F28335_controlCARD.dem.sce" ;];

    subdemolist(:,2) = demopath + subdemolist(:,2);
endfunction

subdemolist = demo_gateway();
clear demo_gateway;
